<?php

namespace TVn7\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20161015182428 extends AbstractMigration implements ContainerAwareInterface
{
    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    public function postUp(Schema $schema) {
        $em = $this->container->get('doctrine')->getManager();
        $membresRepo = $em->getRepository('TVn7UserBundle:Membre');
        $postesRepo = $em->getRepository('TVn7UserBundle:Poste');

        $this->write("Update Postes");

        $role = "ROLE_ADMIN_TOOLS";
        $postes = [ "respo-communication", "respo-informatique" ];

        foreach($postes as $nameposte) {
            $poste = $postesRepo->findBy([ "name_canonical" => $nameposte]);
            if (count($poste) == 1) {
                $poste = $poste[0];
                $this->write(" Add '" . $role . "' to '" . $poste->getName() . "'");
                $poste->addRole($role);
                $membres = $poste->getMembres()->filter(function($membre) {
                    return ($membre->getAnnee() >= 2016);
                });
                foreach($membres as $membre) {
                    $this->write("  Add '" . $role . "' to '" . $membre . "' (" . $membre->getUsername() . ")");
                    $membre->addRole($role);
                }
            }
        }

        $em->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on \'mysql\'.');


    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on \'mysql\'.');


    }
}
